-- name: [CS] SMG4 Crew
-- description: The Funny Youtube Machinima Crew is here in SM64 Coop Deluxe! Play as one of 3 Characters from the SMG4 Series and explore as your favorite bois!\n\n\Modpack by VioletArts\n\n\SMG4 along with other characters included belongs to SMG4 and Glitch Productions
-- deluxe: true
local globalModName = "SMG4 Crew";

if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..globalModName.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MEGGY_MODEL = smlua_model_util_get_id("meggy_violet_geo");
local E_WSMEGGY_MODEL = smlua_model_util_get_id("wsmeggy_violet_geo");
local E_MEGGY_MODEL_OLD = smlua_model_util_get_id("meggyold_violet_geo");

local E_SMG4_MODEL = smlua_model_util_get_id("smg4_violet_geo");
local E_WOTFISMG4_MODEL = smlua_model_util_get_id("wotfismg4_violet_geo");

local E_SMG3_MODEL = smlua_model_util_get_id("smg3_violet_geo");

local E_TARI_MODEL = smlua_model_util_get_id("tari_violet_geo");

local E_PUZZLES_MODEL = smlua_model_util_get_id("puzzles_violet_geo");

local E_MELONY_MODEL = smlua_model_util_get_id("melony_violet_geo");

local E_BOOPKINS_MODEL = smlua_model_util_get_id("boopkins_violet_geo");

local TEX_MEGGY_LIFE_ICON = get_texture_info("meggy_violet_icon")
local TEX_SMG4_LIFE_ICON = get_texture_info("smg4_violet_icon")
local TEX_SMG3_LIFE_ICON = get_texture_info("smg3_violet_icon")
local TEX_TARI_LIFE_ICON = get_texture_info("tari_violet_icon")
local TEX_MEGGYOLD_LIFE_ICON = get_texture_info("meggyold_violet_icon")
local TEX_PUZZLES_LIFE_ICON = get_texture_info("puzzles_violet_icon")
local TEX_MELONY_LIFE_ICON = get_texture_info("melony_violet_icon")

local VOICETABLE_MEGGY = {
    [CHAR_SOUND_ATTACKED] = 'MeggyAttacked.ogg',
    [CHAR_SOUND_COUGHING3] = 'MeggyCough.ogg',
    [CHAR_SOUND_DOH] = 'MeggyDoh.ogg',
    [CHAR_SOUND_DROWNING] = 'MeggyDrown.ogg',
    [CHAR_SOUND_DYING] = 'MeggyDead.ogg',
    [CHAR_SOUND_EEUH] = 'MeggyEeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'MeggyGroundPound.ogg',
    [CHAR_SOUND_HAHA] = 'MeggyHaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'MeggyHaha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'MeggyWoomy.ogg',
    [CHAR_SOUND_HOOHOO] = 'MeggyYahaJump.ogg',
    [CHAR_SOUND_HRMM] = 'MeggyGrab.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'MeggyTired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'MeggyLetsDoThis.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'MeggyComeOn.ogg',
    [CHAR_SOUND_ON_FIRE] = 'MeggyBurning.ogg',
    [CHAR_SOUND_OOOF] = 'MeggyOof.ogg',
    [CHAR_SOUND_OOOF2] = 'MeggyOof.ogg',
    [CHAR_SOUND_PANTING] = 'MeggyPanting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'MeggyPanting.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'MeggyHooKick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'MeggyWahPunch.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'MeggyYahPunch.ogg',
    [CHAR_SOUND_SNORING1] = 'MeggySnore1.ogg',
    [CHAR_SOUND_SNORING2] = 'MeggySnore2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'MeggyBowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'MeggyBoing.ogg',
    [CHAR_SOUND_UH] = 'MeggyUh.ogg',
    [CHAR_SOUND_UH2] = 'MeggyUh.ogg',
    [CHAR_SOUND_UH2_2] = 'MeggyUh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'MeggyYell.ogg',
    [CHAR_SOUND_WHOA] = 'MeggyWoah.ogg',
    [CHAR_SOUND_YAHOO] = 'MeggyYahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'MeggyYahoo.ogg', 'MeggyWaha.ogg', 'MeggyYippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'MeggyYahJump.ogg', 'MeggyWahJump.ogg', 'MeggyHooJump.ogg'},
    [CHAR_SOUND_YAWNING] = 'MeggyYawn.ogg',
}

local VOICETABLE_TARI = {
    [CHAR_SOUND_ATTACKED] = 'TariAttacked.ogg',
    [CHAR_SOUND_COUGHING3] = 'TariCough.ogg',
    [CHAR_SOUND_DOH] = 'TariDoh.ogg',
    [CHAR_SOUND_DROWNING] = 'TariDrown.ogg',
    [CHAR_SOUND_DYING] = 'TariDead.ogg',
    [CHAR_SOUND_EEUH] = 'TariEeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'TariWahPunch.ogg',
    [CHAR_SOUND_HAHA] = 'TariHaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'TariHaha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'TariHereWeGo.ogg',
    [CHAR_SOUND_HOOHOO] = 'TariHoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'MeggyGrab.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'TariTired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'TariLetsDoThis.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'TariOhNo.ogg',
    [CHAR_SOUND_ON_FIRE] = 'TariBurning.ogg',
    [CHAR_SOUND_OOOF] = 'TariOof.ogg',
    [CHAR_SOUND_OOOF2] = 'TariOof.ogg',
    [CHAR_SOUND_PANTING] = 'TariPanting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'TariPanting.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'TariHooKick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'TariWahPunch.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'TariYahPunch.ogg',
    [CHAR_SOUND_SNORING1] = 'TariSnore1.ogg',
    [CHAR_SOUND_SNORING2] = 'TariSnore2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'TariBowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'TariBoing.ogg',
    [CHAR_SOUND_UH] = 'TariUh.ogg',
    [CHAR_SOUND_UH2] = 'TariUh.ogg',
    [CHAR_SOUND_UH2_2] = 'TariUh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'TariFall.ogg',
    [CHAR_SOUND_WHOA] = 'TariWoah.ogg',
    [CHAR_SOUND_YAHOO] = 'TariYahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'TariYahoo.ogg', 'TariWaha.ogg', 'TariYippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'TariYahJump.ogg', 'TariWahJump.ogg', 'TariHooJump.ogg'},
    [CHAR_SOUND_YAWNING] = 'TariYawn.ogg',
}

local VOICETABLE_SMG4 = {
    [CHAR_SOUND_ATTACKED] = 'SMG4Attacked.ogg',
    [CHAR_SOUND_COUGHING3] = 'SMG4Cough.ogg',
    [CHAR_SOUND_DOH] = 'SMG4Doh.ogg',
    [CHAR_SOUND_DROWNING] = 'SMG4Drown.ogg',
    [CHAR_SOUND_DYING] = 'SMG4Dead.ogg',
    [CHAR_SOUND_EEUH] = 'SMG4Eeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'SMG4GroundPoundWah.ogg',
    [CHAR_SOUND_HAHA] = 'SMG4Haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'SMG4Haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'SMG4HereWeGo.ogg',
    [CHAR_SOUND_HOOHOO] = 'SMG4Hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'SMG4Hrmm.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'SMG4ImTired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'SMG4LetsAGo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'SMG4GodDammit.ogg',
    [CHAR_SOUND_ON_FIRE] = 'SMG4Burning.ogg',
    [CHAR_SOUND_OOOF] = 'SMG4Oof.ogg',
    [CHAR_SOUND_OOOF2] = 'SMG4Oof.ogg',
    [CHAR_SOUND_PANTING] = 'SMG4Panting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'SMG4Panting.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'SMG4HooKick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'SMG4WahPunch.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'SMG4YahPunch.ogg',
    [CHAR_SOUND_SNORING1] = 'SMG4Snore1.ogg',
    [CHAR_SOUND_SNORING2] = 'SMG4Snore2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'SMG4Bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'SMG4Boing.ogg',
    [CHAR_SOUND_UH] = 'SMG4Uh.ogg',
    [CHAR_SOUND_UH2] = 'SMG4Uh.ogg',
    [CHAR_SOUND_UH2_2] = 'SMG4Uh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'SMG4Fall.ogg',
    [CHAR_SOUND_WHOA] = 'SMG4Woah.ogg',
    [CHAR_SOUND_YAHOO] = 'SMG4Yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'SMG4Yahoo.ogg', 'SMG4Waha.ogg', 'SMG4Yippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'SMG4YahJump.ogg', 'SMG4WahJump.ogg', 'SMG4HooJump.ogg'},
    [CHAR_SOUND_YAWNING] = 'SMG4Yawn.ogg',
}

local VOICETABLE_SMG3 = {
    [CHAR_SOUND_ATTACKED] = 'SMG3Attacked.ogg',
    [CHAR_SOUND_COUGHING3] = 'SMG3Cough.ogg',
    [CHAR_SOUND_DOH] = 'SMG3Doh.ogg',
    [CHAR_SOUND_DROWNING] = 'SMG3Drowning.ogg',
    [CHAR_SOUND_DYING] = 'SMG3Dying.ogg',
    [CHAR_SOUND_EEUH] = 'SMG3Eeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'SMG3Wah.ogg',
    [CHAR_SOUND_HAHA] = 'SMG3Haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'SMG3Haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'SMG3HereWeGo.ogg',
    [CHAR_SOUND_HOOHOO] = 'SMG3Hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'SMG3Grab.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'SMG3ImTired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'SMG3LetsAGo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'SMG3ComeOn.ogg',
    [CHAR_SOUND_ON_FIRE] = 'SMG3Burning.ogg',
    [CHAR_SOUND_OOOF] = 'SMG3Oof.ogg',
    [CHAR_SOUND_OOOF2] = 'SMG3Oof.ogg',
    [CHAR_SOUND_PANTING] = 'SMG3Panting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'SMG3Panting.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'SMG3Hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'SMG3Wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'SMG3Yah.ogg',
    [CHAR_SOUND_SNORING1] = 'SMG3Snore1.ogg',
    [CHAR_SOUND_SNORING2] = 'SMG3Snore2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'SMG3Bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'SMG3Boing.ogg',
    [CHAR_SOUND_UH] = 'SMG3Uh.ogg',
    [CHAR_SOUND_UH2] = 'SMG3Uh.ogg',
    [CHAR_SOUND_UH2_2] = 'SMG3Uh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'SMG3Falling.ogg',
    [CHAR_SOUND_WHOA] = 'SMG3Woah.ogg',
    [CHAR_SOUND_YAHOO] = 'SMG3Yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'SMG3Yahoo.ogg', 'SMG3Woohoo.ogg', 'SMG3Yippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'SMG3Yah.ogg', 'SMG3Wah.ogg', 'SMG3Hoo.ogg'},
    [CHAR_SOUND_YAWNING] = 'SMG3Yawning.ogg',
}

local VOICETABLE_MEGGYOLD = {
    [CHAR_SOUND_ATTACKED] = 'MeggyOldDamaged.ogg',
    [CHAR_SOUND_DOH] = 'MeggyOldDoh.ogg',
    [CHAR_SOUND_DROWNING] = 'MeggyOldDrowning.ogg',
    [CHAR_SOUND_DYING] = 'MeggyOldDeath.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'MeggyOldWah.ogg',
    [CHAR_SOUND_HAHA] = 'MeggyOldLaugh.ogg',
    [CHAR_SOUND_HAHA_2] = 'MeggyOldLaugh.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'MeggyOldWoomy.ogg',
    [CHAR_SOUND_HOOHOO] = 'MeggyOldHoohoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'MeggyOldOuch.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'MeggyOldLetsGo.ogg',
    [CHAR_SOUND_ON_FIRE] = 'MeggyOldBurning.ogg',
    [CHAR_SOUND_OOOF] = 'MeggyOldOof.ogg',
    [CHAR_SOUND_OOOF2] = 'MeggyOldOof.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'MeggyOldHoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'MeggyOldWah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'MeggyOldPunch1.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'MeggyOldBowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'MeggyOldBoing.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'MeggyOldFalling.ogg',
    [CHAR_SOUND_WAH2] = 'MeggyOldWah.ogg',
    [CHAR_SOUND_WHOA] = 'MeggyOldWoah.ogg',
    [CHAR_SOUND_YAHOO] = 'MeggyOldYahoo.ogg',
    [CHAR_SOUND_EEUH] = 'MeggyOldCliff.ogg',
    [CHAR_SOUND_PANTING] = 'MeggyOldPanting.ogg',
    [CHAR_SOUND_COUGHING1] = 'Cough.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'MeggyOldTired.ogg',
    [CHAR_SOUND_SNORING1] = 'MeggyOldSnoreIn.ogg',
    [CHAR_SOUND_SNORING2] = 'MeggyOldSnoreOut.ogg',
    [CHAR_SOUND_UH] = 'MeggyOldUngh.ogg',
    [CHAR_SOUND_UH2] = 'MeggyOldUngh.ogg',
    [CHAR_SOUND_UH2_2] = 'MeggyOldUngh.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'MeggyOldYippee.ogg', 'MeggyOldWaha.ogg', 'MeggyOldYahoo.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'MeggyOldHooJump.ogg', 'MeggyOldWah.ogg', 'MeggyOldHoo.ogg'},
    [CHAR_SOUND_YAWNING] = 'MeggyOldYawn.ogg',
}

local VOICETABLE_PUZZLES = {
    [CHAR_SOUND_ATTACKED] = 'PuzzlesHurt.ogg',
    [CHAR_SOUND_COUGHING3] = 'PuzzlesCough.ogg',
    [CHAR_SOUND_DOH] = 'PuzzlesDoh.ogg',
    [CHAR_SOUND_DROWNING] = 'PuzzlesDrown.ogg',
    [CHAR_SOUND_DYING] = 'PuzzlesDead.ogg',
    [CHAR_SOUND_EEUH] = 'PuzzlesEeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'PuzzlesWahPunch.ogg',
    [CHAR_SOUND_HAHA] = 'PuzzlesHaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'PuzzlesHaha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'PuzzlesHereWeGo.ogg',
    [CHAR_SOUND_HOOHOO] = 'PuzzlesHoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'PuzzlesGrab.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'PuzzlesTired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'PuzzlesLetTheShowBegin.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'PuzzlesDammit.ogg',
    [CHAR_SOUND_ON_FIRE] = 'PuzzlesBurning.ogg',
    [CHAR_SOUND_OOOF] = 'PuzzlesOof.ogg',
    [CHAR_SOUND_OOOF2] = 'PuzzlesOof.ogg',
    [CHAR_SOUND_PANTING] = 'PuzzlesPanting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'PuzzlesPanting.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'PuzzlesHooKick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'PuzzlesWahPunch.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'PuzzlesYahPunch.ogg',
    [CHAR_SOUND_SNORING1] = 'PuzzlesSnore1.ogg',
    [CHAR_SOUND_SNORING2] = 'PuzzlesSnore2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'PuzzlesBowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'PuzzlesBoing.ogg',
    [CHAR_SOUND_UH] = 'PuzzlesUh.ogg',
    [CHAR_SOUND_UH2] = 'PuzzlesUh.ogg',
    [CHAR_SOUND_UH2_2] = 'PuzzlesUh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'PuzzlesFall.ogg',
    [CHAR_SOUND_WHOA] = 'PuzzlesWoah.ogg',
    [CHAR_SOUND_YAHOO] = 'PuzzlesYahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'PuzzlesYahoo.ogg', 'PuzzlesWaha.ogg', 'PuzzlesYippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'PuzzlesYahPunch.ogg', 'PuzzlesWahJump.ogg', 'PuzzlesHooKick.ogg'},
    [CHAR_SOUND_YAWNING] = 'PuzzlesYawn.ogg',
}

local VOICETABLE_MELONY = {
    [CHAR_SOUND_ATTACKED] = 'MelonyHurt.ogg',
    [CHAR_SOUND_COUGHING3] = 'MelonyCough.ogg',
    [CHAR_SOUND_DOH] = 'MelonyDoh.ogg',
    [CHAR_SOUND_DROWNING] = 'MelonyDrown.ogg',
    [CHAR_SOUND_DYING] = 'MelonyDead.ogg',
    [CHAR_SOUND_EEUH] = 'MelonyEeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'MelonyWah.ogg',
    [CHAR_SOUND_HAHA] = 'MelonyHaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'MelonyHaha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'MelonyHereWeGo.ogg',
    [CHAR_SOUND_HOOHOO] = 'MelonyHoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'MelonyGrab.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'MelonyTired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'MelonyLetsGo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'MelonyOhNo.ogg',
    [CHAR_SOUND_ON_FIRE] = 'MelonyBurning.ogg',
    [CHAR_SOUND_OOOF] = 'MelonyOof.ogg',
    [CHAR_SOUND_OOOF2] = 'MelonyOof.ogg',
    [CHAR_SOUND_PANTING] = 'MelonyPanting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'MelonyPanting.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'MelonyHoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'MelonyWah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'MelonyYah.ogg',
    [CHAR_SOUND_SNORING1] = 'MelonySnore1.ogg',
    [CHAR_SOUND_SNORING2] = 'MelonySnore2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'MelonyBowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'MelonyBoing.ogg',
    [CHAR_SOUND_UH] = 'MelonyUh.ogg',
    [CHAR_SOUND_UH2] = 'MelonyUh.ogg',
    [CHAR_SOUND_UH2_2] = 'MelonyUh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'MelonyFall.ogg',
    [CHAR_SOUND_WHOA] = 'MelonyWhoa.ogg',
    [CHAR_SOUND_YAHOO] = 'MelonyYahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'MelonyYahoo.ogg', 'MelonyWaha.ogg', 'MelonyYippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'MelonyYah.ogg', 'MelonyWah.ogg', 'MelonyHooJump.ogg'},
    [CHAR_SOUND_YAWNING] = 'MelonyYawn.ogg',
}

local MEGGY_CAPMODELS = {
    normal = smlua_model_util_get_id("meggy_violet_cap_geo"),
    wing = smlua_model_util_get_id("meggy_violet_cap_wing_geo"),
    metal = smlua_model_util_get_id("meggy_violet_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("meggy_violet_cap_metal_wing_geo"),
}

local WSMEGGY_CAPMODELS = {
    normal = smlua_model_util_get_id("wsmeggy_violet_cap_geo"),
    wing = smlua_model_util_get_id("wsmeggy_violet_cap_wing_geo"),
    metal = smlua_model_util_get_id("wsmeggy_violet_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("wsmeggy_violet_cap_metal_wing_geo"),
}

local SMG4_CAPMODELS = {
    normal = smlua_model_util_get_id("smg4_violet_cap_geo"),
    wing = smlua_model_util_get_id("smg4_violet_cap_wing_geo"),
    metal = smlua_model_util_get_id("smg4_violet_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("smg4_violet_cap_metal_wing_geo"),
}

local SMG3_CAPMODELS = {
    normal = smlua_model_util_get_id("smg3_violet_cap_geo"),
    wing = smlua_model_util_get_id("smg3_violet_cap_wing_geo"),
    metal = smlua_model_util_get_id("smg3_violet_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("smg3_violet_cap_metal_wing_geo"),
}

local PUZZLES_CAPMODELS = {
    normal = smlua_model_util_get_id("puzzles_violet_cap_geo"),
    wing = smlua_model_util_get_id("puzzles_violet_cap_wing_geo"),
    metal = smlua_model_util_get_id("puzzles_violet_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("puzzles_violet_cap_metal_wing_geo"),
}

local MEGGY_PALETTE = {
    [PANTS] = "494949",
    [SHIRT] = "FFFFFF",
    [GLOVES] = "525A4C",
    [SHOES] = "503325",
    [HAIR] = "FF9035",
    [SKIN] = "FFBF8D",
    [CAP] = "E4302A",
    [EMBLEM] = "7C8D6F"
}

local WSMEGGY_PALETTE = {
    [PANTS] = "494949",
    [SHIRT] = "C2C3A6",
    [GLOVES] = "643720",
    [SHOES] = "503325",
    [HAIR] = "FF9035",
    [SKIN] = "FFBF8D",
    [CAP] = "B24947",
    [EMBLEM] = "74523E"
}

local SMG4_PALETTE = {
    [PANTS] = "FFFFFF",
    [SHIRT] = "3700F6",
    [GLOVES] = "FFFFFF",
    [SHOES] = "694A2E",
    [HAIR] = "202028",
    [SKIN] = "FEC179",
    [CAP] = "3700F6",
    [EMBLEM] = "3700F6"
}

local WOTFISMG4_PALETTE = {
    [PANTS] = "342046",
    [SHIRT] = "3700F6",
    [GLOVES] = "FFFFFF",
    [SHOES] = "3E3F5A",
    [HAIR] = "202028",
    [SKIN] = "FEC179",
    [CAP] = "3700F6",
    [EMBLEM] = "3700F6"
}

local SMG3_PALETTE = {
    [PANTS] = "232133",
    [SHIRT] = "4F14A3",
    [GLOVES] = "FFFFFF",
    [SHOES] = "202028",
    [HAIR] = "202028",
    [SKIN] = "FEC179",
    [CAP] = "4F14A3",
    [EMBLEM] = "FFFFFF"
}

local TARI_PALETTE = {
    [PANTS] = "9B8A71",
    [SHIRT] = "3B90E5",
    [GLOVES] = "49484D",
    [SHOES] = "FFFFFF",
    [HAIR] = "4789EA",
    [SKIN] = "FFCDA8",
    [CAP] = "E4302A",
    [EMBLEM] = "877A65"
}

local MEGGYOLD_PALETTE = {
    [PANTS]  = "232327",
    [SHIRT]  = "ffffff",
    [GLOVES] = "ffffff",
    [SHOES]  = "3F2000",
    [HAIR]   = "DB7900",
    [SKIN]   = "EAB371",
    [CAP]    = "C52B3A",
}

local PUZZLES_PALETTE = {
    [PANTS] = "1B1B1B",
    [SHIRT] = "696969",
    [GLOVES] = "FFFFFF",
    [SHOES] = "FFFFFF",
    [HAIR] = "4C4C4C",
    [SKIN] = "838383",
    [CAP] = "242424",
    [EMBLEM] = "5A5A5A"
}

local MELONY_PALETTE = {
    [PANTS] = "4C4C4C",
    [SHIRT] = "FF6F82",
    [GLOVES] = "73FF00",
    [SHOES] = "4C4C4C",
    [HAIR] = "79FF4E",
    [SKIN] = "FEDCAB",
    [CAP] = "FF6F82",
    [EMBLEM] = "FF6F82"
}

local BOOPKINS_PALETTE = {
    [PANTS] = "B7DBC2",
    [SHIRT] = "FFE29F",
    [GLOVES] = "FFFFFF",
    [SHOES] = "5A483E",
    [HAIR] = "38D4FF",
    [SKIN] = "57C783",
    [CAP] = "38D4FF",
    [EMBLEM] = "57C783"
}

local ANIMTABLE_BOOPKINS = {
    [CHAR_ANIM_AIR_KICK] = 'boopkins_air_kick',
    [CHAR_ANIM_GROUND_KICK] = 'boopkins_ground_kick',
}

local ANIMTABLE_MELONY = {
    [CHAR_ANIM_STOP_CROUCHING] = "melony_stop_crouching",
    [CHAR_ANIM_START_CROUCHING] = "melony_start_crouching",
    [CHAR_ANIM_CROUCHING] = "melony_crouching",
    [CHAR_ANIM_START_CRAWLING] = "melony_start_crawling",
    [CHAR_ANIM_STOP_CRAWLING] = "melony_stop_crawling",
    [CHAR_ANIM_CRAWLING] = "melony_crawling",
    [CHAR_ANIM_AIR_KICK] = 'melony_air_kick',
    [CHAR_ANIM_GROUND_KICK] = 'melony_ground_kick',
    [CHAR_ANIM_SLIDE_KICK] = 'melony_slide_kick',
}

local charSelectLoaded = false

local function on_character_select_load()
    CT_MEGGY = _G.charSelect.character_add("Meggy Spletzer", {"Splatfest Champ, former Inkling,", "bad cook, whatever you wanna", "call her, Meggy Spletzer makes her", "appearance in SM64, as she", "helps Mario and friends", "defeat the great Bowser!", "", "Voice by SaltedPearls"}, "VioletArts", {r = 255, g = 144, b = 53}, E_MEGGY_MODEL, CT_MARIO, TEX_MEGGY_LIFE_ICON)
    _G.charSelect.character_add_caps(E_MEGGY_MODEL, MEGGY_CAPMODELS)
    _G.charSelect.character_add_voice(E_MEGGY_MODEL, VOICETABLE_MEGGY)
    _G.charSelect.character_add_palette_preset(E_MEGGY_MODEL, MEGGY_PALETTE)

    _G.charSelect.character_add_voice(E_MEGGY_MODEL_OLD, VOICETABLE_MEGGYOLD)
    _G.charSelect.character_add_palette_preset(E_MEGGY_MODEL_OLD, MEGGYOLD_PALETTE)

    _G.charSelect.character_add_caps(E_WSMEGGY_MODEL, WSMEGGY_CAPMODELS)
    _G.charSelect.character_add_voice(E_WSMEGGY_MODEL, VOICETABLE_MEGGY)
    _G.charSelect.character_add_palette_preset(E_WSMEGGY_MODEL, WSMEGGY_PALETTE)
    
    CT_SMG4 = _G.charSelect.character_add("SMG4", {"The Meme Boi has arrived in", "the Mushroom Kingdom! What", "kinds of crazy antics will", "he go on as he uses", "the power of memes to save", "the day!", "", "Voiced by Malik Radwan"}, "SM64Rise", {r = 55, g = 0, b = 246}, E_SMG4_MODEL, CT_MARIO, TEX_SMG4_LIFE_ICON)
    _G.charSelect.character_add_caps(E_SMG4_MODEL, SMG4_CAPMODELS)
    _G.charSelect.character_add_voice(E_SMG4_MODEL, VOICETABLE_SMG4)
    _G.charSelect.character_add_palette_preset(E_SMG4_MODEL, SMG4_PALETTE)

    _G.charSelect.character_add_caps(E_WOTFISMG4_MODEL, SMG4_CAPMODELS)
    _G.charSelect.character_add_voice(E_WOTFISMG4_MODEL, VOICETABLE_SMG4)
    _G.charSelect.character_add_palette_preset(E_WOTFISMG4_MODEL, WOTFISMG4_PALETTE)

    CT_SMG3 = _G.charSelect.character_add("SMG3", {"Heroes beware, the former", "villain and protector of the", "Internet Graveyard is here", "to wreck havoc upon the", "Mushroom Kingdom but I guess", "it wouldn't be too bad", "to help a couple friends out...", ""}, "SM64Rise", {r = 79, g = 20, b = 163}, E_SMG3_MODEL, CT_MARIO, TEX_SMG3_LIFE_ICON)
    _G.charSelect.character_add_caps(E_SMG3_MODEL, SMG3_CAPMODELS)
    _G.charSelect.character_add_palette_preset(E_SMG3_MODEL, SMG3_PALETTE)
    _G.charSelect.character_add_voice(E_SMG3_MODEL, VOICETABLE_SMG3)

    CT_TARI = _G.charSelect.character_add("Tari", {"The gaming girl extrodinare,", "Tari, makes her appearance in", "SM64, will she overcome her", "cowardice and help her friends", "defeat the great Bowser?", "Or will there be more", "trouble that occurs?", "", "Voiced by AlessaW/VAButterfly"}, "Yuyake", {r = 59, g = 144, b = 229}, E_TARI_MODEL, CT_MARIO, TEX_TARI_LIFE_ICON)
    _G.charSelect.character_add_voice(E_TARI_MODEL, VOICETABLE_TARI)
    _G.charSelect.character_add_palette_preset(E_TARI_MODEL, TARI_PALETTE)

    CT_PUZZLES = _G.charSelect.character_add("Mr. Puzzles", {"The madman with a TV as", "his head, Mr. Puzzles invites", "you to join his little", "game of EXCITEMENT, JOY", "and maybe a little bit", "of death along the way...","So come on down and maybe", "YOU can help him get his", "5 Star Rating!","","Voiced by Shads"}, "VioletArts", {r = 105, g = 105, b = 105}, E_PUZZLES_MODEL, CT_MARIO, TEX_PUZZLES_LIFE_ICON)
    _G.charSelect.character_add_caps(E_PUZZLES_MODEL, PUZZLES_CAPMODELS)
    _G.charSelect.character_add_voice(E_PUZZLES_MODEL, VOICETABLE_PUZZLES)
    _G.charSelect.character_add_palette_preset(E_PUZZLES_MODEL, PUZZLES_PALETTE)

    CT_MELONY = _G.charSelect.character_add("Melony", {"The happy and sleepy girl","has arrived, while she may","be happy and a litle","childish, don't let that","happiness decieve you as","one bad mistake may result","in your ultimate doom.","Will this goddess beat the","king? Or will it be","time to go to sleep?","","Voiced by ShiningLotl"}, "VioletArts", {r = 255, g = 111, b = 130}, E_MELONY_MODEL, CT_TOAD, TEX_MELONY_LIFE_ICON)
    _G.charSelect.character_add_palette_preset(E_MELONY_MODEL, MELONY_PALETTE)
    _G.charSelect.character_add_voice(E_MELONY_MODEL, VOICETABLE_MELONY)
    _G.charSelect.character_add_animations(E_MELONY_MODEL, ANIMTABLE_MELONY)

    if _G.charSelect.credit_add then
        _G.charSelect.credit_add(globalModName, "VioletArts", "Pack Creator")
        _G.charSelect.credit_add(globalModName, "SM64Rise", "SMG4 / SMG3 Models")
        _G.charSelect.credit_add(globalModName, "Yuyake", "Tari Model")
        _G.charSelect.credit_add(globalModName, "Squishy", "Alt Skin Code")
        _G.charSelect.credit_add(globalModName, "SaltedPearls", "Meggy Voice Actor")
        _G.charSelect.credit_add(globalModName, "ShiftProducer", "Legacy Meggy Voice Actor")
        _G.charSelect.credit_add(globalModName, "Malik Radwan", "SMG4 Voice Actor")
        _G.charSelect.credit_add(globalModName, "AlessaW/VAButterfly", "Tari Voice Actor")
        _G.charSelect.credit_add(globalModName, "Shads", "Mr. Puzzles Voice Actor")
        _G.charSelect.credit_add(globalModName, "ShiningLotl", "Melony Voice Actor")
        _G.charSelect.credit_add(globalModName, "LuigiDeathStare", "SMG3 Voice Actor")
    end

    altCostumes = {
        [CT_MEGGY] = {
            currSkin = 1,
            {name = "", model = E_MEGGY_MODEL, desc = _G.charSelect.character_get_current_table(CT_MEGGY).description},
            {name = "Western Speghetti", model = E_WSMEGGY_MODEL, desc = {"Yeehaw! Meggy has arrived", "in some western styled", "clothing from one of her", "past adventures!"}},
            {name = "Legacy", model = E_MEGGY_MODEL_OLD, desc = {"The Splatfest Champion has arrived!", "", "Voice by ShiftProducer"}},
        },
        [CT_SMG4] = {
            currSkin = 1,
            {name = "", model = E_SMG4_MODEL, desc = _G.charSelect.character_get_current_table(CT_SMG4).description},
            {name = "War of the Fat Italians 2023", model = E_WOTFISMG4_MODEL, desc = {"SMG4 has dappered up", "in a sweet spy outfit", "from one of his", "previous adventures"}},
        },
    }

    charSelectLoaded = true
end

local function on_character_sound(m, sound)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MEGGY then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MEGGYOLD then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_TARI then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SMG4 then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_PUZZLES then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MELONY then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SMG3 then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MEGGY then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MEGGYOLD then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_TARI then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SMG4 then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_PUZZLES then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MELONY then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SMG3 then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)

------------------------------------------
---- Alt Costume code from by Squishy ----
------------ for Azumanga Pack -----------
---- Modified by Squishy for SMG4 Crew ---
------------------------------------------

local character_edit = _G.charSelect.character_edit
local character_get_current_number = _G.charSelect.character_get_current_number
local character_get_current_table = _G.charSelect.character_get_current_table
local get_options_status = _G.charSelect.get_options_status
local get_menu_color = _G.charSelect.get_menu_color
local hook_render_in_menu = _G.charSelect.hook_render_in_menu

local table_insert = table.insert
local play_sound = play_sound
local djui_hud_get_screen_width = djui_hud_get_screen_width
local djui_hud_measure_text = djui_hud_measure_text
local djui_hud_set_color = djui_hud_set_color
local djui_hud_set_resolution = djui_hud_set_resolution
local djui_hud_set_rotation = djui_hud_set_rotation
local djui_hud_set_font = djui_hud_set_font
local djui_hud_print_text = djui_hud_print_text
local djui_hud_render_rect = djui_hud_render_rect
local maxf = maxf
local math_min = math.min
local math_max = math.max
local math_sin = math.sin

local function update_character_skin(currChar, currAlt)
    local currSkin = altCostumes[currChar][currAlt]
    if altCostumes[currChar].desc == nil then
        altCostumes[currChar].desc = character_get_current_table().description
    end
    local description = {}
    if currSkin.desc ~= nil then
        for i = 1, #currSkin.desc do
            table_insert(description, currSkin.desc[i])
        end
    else
        for i = 1, #altCostumes[currChar].desc do
            table_insert(description, altCostumes[currChar].desc[i])
        end
    end
    if currSkin.name ~= "" then
        table_insert(description, "")
        table_insert(description, "Current Outfit: "..currSkin.name)
    end
    character_edit(currChar, nil, description, nil, nil, currSkin.model, nil, nil)
    local cameraToObject = gMarioStates[0].marioObj.header.gfx.cameraToObject
    play_sound(SOUND_MENU_MESSAGE_NEXT_PAGE, cameraToObject)
end

local inputLockTimer = 0
local buttonAnimTimer = 0

local MATH_DIVIDE_320 = 1/320

local latencyValueTable = {12, 6, 3}

local function hud_render()
    local width = djui_hud_get_screen_width() + 1.4
    local widthScale = maxf(width, 321.4) * MATH_DIVIDE_320
    local currChar = character_get_current_number()
    local charColors = character_get_current_table().color
    
    -- Mimick button swaying, which is missing from the paper code
    local buttonAnim = 0
    local charSelectAnim = get_options_status(_G.charSelect.optionTableRef.anims)
    if charSelectAnim > 0 then
        buttonAnimTimer = buttonAnimTimer + 1
        buttonAnim = math_sin(buttonAnimTimer * 0.05) * 2.5 + 5
    else
        buttonAnim = 10
    end

    local inputLockTimerTo = latencyValueTable[get_options_status(_G.charSelect.optionTableRef.inputLatency) + 1]

    if altCostumes[currChar] ~= nil then
        ---@type Controller
        local c = _G.charSelect.controller
        local currAlts = altCostumes[currChar]

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local inputLockTimerAnim = 0

        local buttonX = 20 * widthScale + buttonAnim
        local x1 = buttonX - 4
        local x2 = x1 + 73
        local y = 97

        if charSelectAnim > 0 then
            inputLockTimerAnim = inputLockTimer/inputLockTimerTo * 3
            x1 = x1 + math_min(inputLockTimerAnim, 0)
            x2 = x2 + math_max(inputLockTimerAnim, 0)
        end
        -- Left Arrow
        if currAlts.currSkin > 1 then
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_set_rotation(0x2000, 0.5, 0.5)
            djui_hud_render_rect(x1, y, 5, 5)
            djui_hud_set_color(0, 0, 0, 255)
            djui_hud_set_rotation(0x0000, 0.5, 0.5)
            djui_hud_render_rect(x1 + 2.5, y - 2, 6, 8)
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_render_rect(buttonX, y - 3, 1, 10)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                currAlts.currSkin = math_max(currAlts.currSkin - 1, 1)
                update_character_skin(currChar, currAlts.currSkin)
                inputLockTimer = -inputLockTimerTo
            end
        end
        -- Right Arrow
        if currAlts.currSkin < #currAlts then
            -- Changed arrows to mimick the ones seen in the options menu
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_set_rotation(0x2000, 0.5, 0.5)
            djui_hud_render_rect(x2, y, 5, 5)
            djui_hud_set_color(0, 0, 0, 255)
            djui_hud_set_rotation(0x0000, 0.5, 0.5)
            djui_hud_render_rect(x2 - 3.5, y - 2, 6, 8)
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_render_rect(buttonX + 69, y - 3, 1, 10)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                currAlts.currSkin = currAlts.currSkin + 1
                update_character_skin(currChar, currAlts.currSkin)
                inputLockTimer = inputLockTimerTo
            end
        end
        -- use an input lock to prevent cycling too fast
        if inputLockTimer > 0 then
            inputLockTimer = inputLockTimer - 1
        elseif inputLockTimer < 0 then
            inputLockTimer = inputLockTimer + 1
        end
    end
end

hook_render_in_menu(hud_render)
